// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "pang.h"
#include "ChildView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView() : maxIterations (1000)
{
	iterations = 0;
}

CChildView::~CChildView()
{
	delete m_pBitmap;
	delete m_pdcDisplayMemory;
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_COMMAND(ID_START, OnStart)
	ON_COMMAND(ID_STOP, OnStop)
	ON_WM_LBUTTONDOWN()
	ON_WM_KEYDOWN()
	ON_WM_CLOSE()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CRect rectUpdate;
	CPaintDC dc(this); // device context for painting
	
	dc.GetClipBox(&rectUpdate);
	CBitmap *pOldBitmap = m_pdcDisplayMemory->SelectObject(m_pBitmap);
	m_pdcDisplayMemory->SelectClipRgn(NULL);
	m_pdcDisplayMemory->IntersectClipRect(&rectUpdate);

	CBrush backgroundBrush((COLORREF)::GetSysColor(COLOR_WINDOW));
	CBrush* pOldBrush = m_pdcDisplayMemory->SelectObject(&backgroundBrush);
	m_pdcDisplayMemory->PatBlt(rectUpdate.left, rectUpdate.top, rectUpdate.Width(), rectUpdate.Height(), PATCOPY);

	// Draw your drawings after this line only
	char temp[10];
	itoa(maxIterations - iterations, temp, 10);
	CString s("Time left = ");
	s += temp;
	m_pdcDisplayMemory->TextOut(0, 15, s);

	myPang.Draw(*m_pdcDisplayMemory);

	// Don't draw anything after this line
	dc.BitBlt(rectUpdate.left, rectUpdate.top, rectUpdate.Width(), rectUpdate.Height(), m_pdcDisplayMemory, rectUpdate.left, rectUpdate.top, SRCCOPY);
	m_pdcDisplayMemory->SelectObject(pOldBitmap);
	m_pdcDisplayMemory->SelectObject(pOldBrush);

	// Do not call CWnd::OnPaint() for painting messages
}


void CChildView::OnStart() 
{
	// TODO: Add your command handler code here
	iterations = 0;
	MSG message;
//	CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
//	pStatus = pFrame->GetStatusBar();
//	pStatus->SetPaneText (0, "Message Line");
	myPang.Start();
	while (iterations < maxIterations)
	{
		myPang.RunOnce();
		if (!myPang.GetRunning())
			iterations = maxIterations;
		Invalidate(false);
		for (int i=0; i<1000; i++)
		{
			for (int j=0; j<10000; j++);
			if (::PeekMessage(&message, NULL, 0, 0, PM_REMOVE))
			{
				::TranslateMessage(&message);
				::DispatchMessage(&message);
			}
		};
		iterations++;
	}

}

void CChildView::OnStop() 
{
	// TODO: Add your command handler code here
	iterations = maxIterations;
	myPang.Stop();	
}

void CChildView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CWnd ::OnLButtonDown(nFlags, point);
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
//	mouseX = nChar;
	if(nChar == 37)
	{
		myPang.MovePlayerLeft();
	}
	else if(nChar == 39)
	{
		myPang.MovePlayerRight();
	}
	else if(nChar == ' ')
	{
		myPang.Fire();
	}
	CWnd ::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CChildView::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	OnStop();
	
	CWnd ::OnClose();
}

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd ::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	m_pdcDisplayMemory = new CDC;
	m_pBitmap = new CBitmap;
	if (m_pdcDisplayMemory->GetSafeHdc() == NULL)
	{
		CClientDC dc(this);
		CRect rectMax(0, 0, 1000, 800);
		dc.LPtoDP(rectMax);
		m_pdcDisplayMemory->CreateCompatibleDC(&dc);
		m_pBitmap->CreateCompatibleBitmap(&dc, 1000, 800);
	}
	return 0;
}
