// Fire.cpp: implementation of the CFire class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "pang.h"
#include "Fire.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFire::CFire()
{
	Initialize();
}

void CFire::Initialize()
{
	fired = false;
	x = 500;
	y = 100;
	timeLeft = 10;

}

CFire::~CFire()
{

}

void CFire::Draw(CDC &dc)
{
	if (fired)
	{
		CBrush brush1, *pTempBrush;
		brush1.CreateSolidBrush(RGB(216, 189, 34));

		pTempBrush = (CBrush*)dc.SelectObject(brush1);

		// Save original brush.
		CBrush OrigBrush;
		OrigBrush.FromHandle((HBRUSH)pTempBrush);

		dc.Rectangle(x, y, x+5, 600);
		
		// Restore original brush
		dc.SelectObject(&OrigBrush);
	}
}

bool CFire::GetFired()
{
	return fired;
}

void CFire::SetFired(bool value)
{
	fired = value;	
}

void CFire::Fire(int position)
{
	if (!fired)
	{
		Initialize();
		fired = true;
		x = position;
	}
}

void CFire::Update()
{
	if(timeLeft == 0)
		fired = false;
	else
		timeLeft--;
}

void CFire::Collided()
{

}

void CFire::GetRectCoords (int arr[])
{
	arr[0] = x;
	arr[1] = y;
	arr[2] = x+5;
	arr[3] = 600;
}